package org.processmining.generalizedconformance.algorithms.alignment;

import gnu.trove.map.TObjectIntMap;
import gnu.trove.map.TObjectShortMap;
import gnu.trove.map.hash.TObjectIntHashMap;
import nl.tue.astar.Trace;
import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventClasses;
import org.deckfour.xes.model.XLog;
import org.processmining.plugins.etm.model.narytree.replayer.AStarAlgorithm;

import java.util.Map;

/**
 * Created by andreas on 4/5/17.
 */
public class LogAbstraction extends AStarAlgorithm {
    public LogAbstraction() {
    }

    public LogAbstraction(XEventClasses classes) {
        super(classes);
    }

    public LogAbstraction(XLog log, XEventClasses classes, Map<XEventClass, Integer> activity2Cost) {
        super(log, classes, activity2Cost);
    }

    public LogAbstraction(LogAbstraction abstraction, TObjectIntMap<Trace> converted, int lengthLongestTrace, int[] maxOccInTrace) {
        super(abstraction, converted, lengthLongestTrace, maxOccInTrace);
    }

    public LogAbstraction clone(){
        TObjectIntMap<Trace> newMap = new TObjectIntHashMap<>(converted);
        LogAbstraction clone = new LogAbstraction(this, newMap, this.lengthLongestTrace, maxOccInTrace);
        return clone;
    }
}
