package org.processmining.generalizedconformance.algorithms.heuristic.processtree;

import org.processmining.processtree.Block;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.impl.AbstractTask;
import org.processmining.processtree.impl.ProcessTreeImpl;

import java.util.UUID;

public class TreeWrapper {

	public static ProcessTree getWrappedTree(ProcessTree tree){
		try {
			ProcessTree copyTree = new ProcessTreeImpl(tree.getName());
			Node wrappedRoot = wrap(copyTree, tree.getRoot());
			copyTree.setRoot(wrappedRoot);
			return copyTree;
		} catch (Exception e){
			e.printStackTrace();
		}
		return null;
	}

	private static Node wrap(ProcessTree newTree, Node node) throws Exception {
		NodeWrapper wrapper = null;
		Node newNode = null;
		try {
			if (node instanceof AbstractTask.Manual){
				newNode = new AbstractTask.Manual(node.getID(), node.getName());
			} else {
				newNode = node.getClass().getConstructor(UUID.class, String.class).newInstance(node.getID(), node.getName());
			}
			
		} catch (NoSuchMethodException e){
			System.out.println("Debug me!");
		}
		if (!node.isLeaf()){
			wrapper = new BlockWrapper((Block) newNode);
		} else {
			wrapper = new NodeWrapper(newNode);
		}
		newTree.addNode(wrapper);
		
		if (!node.isLeaf()){
			BlockWrapper bWrapper = (BlockWrapper) wrapper;
			for (Node child : ((Block)node).getChildren()){
				Node wrappedChild = wrap(newTree, child);
				bWrapper.addChild(wrappedChild);
			}
		}
		return wrapper;
	}
}
