package org.processmining.generalizedconformance.algorithms.miner;

import org.processmining.generalizedconformance.Utils;
import org.processmining.generalizedconformance.algorithms.mover.TreeMover;
import org.processmining.generalizedconformance.algorithms.mover.TreeMoverConfig;
import org.processmining.processtree.ProcessTree;

public class GeneralizedMinerImpl extends AbstractGeneralizedMiner {

	private TreeMover mover;
	
	private ProcessTree targetTree; 
	
	public GeneralizedMinerImpl(){
		super();
	}
	
	protected void doInit() {
		targetTree = Utils.mineProcessTree(log, 0.0);
		
		mover = new TreeMover(tree, targetTree, TreeMoverConfig.getInstance());
	}

	public ProcessTree getProcessTreeBasedOnTrust(double trustInLog, double trustInModel) {
		return mover.getProcessTreeBasedOnTrust(trustInLog, trustInModel);
	}
	
	public ProcessTree getTargetTree(){
		return targetTree;
	}

}
