package org.processmining.generalizedconformance.algorithms.miner;

import org.deckfour.xes.model.XLog;
import org.processmining.generalizedconformance.algorithms.miner.distance.SimpleDistanceFunction;
import org.processmining.plugins.etm.model.narytree.NAryTree;
import org.processmining.plugins.etm.model.narytree.NAryTreeImpl;
import org.processmining.plugins.stochasticpetrinet.StochasticNetUtils;

/**
 * Created by andreas on 5/16/17.
 */
public class LocalSearchDiscovery {

    public static NAryTree discoverTree(XLog log){
        return discoverTree(log, false);
    }
    /**
     * Special case of the local search miner is discovery
     * @param log
     * @param debug whether to display the intermediate states on GUI
     * @return
     */
    public static NAryTree discoverTree(XLog log, boolean debug){
        NAryTree emptyTree = new NAryTreeImpl(new int[]{1},new short[]{NAryTree.TAU}, new int[]{NAryTree.NONE});
        LocalSearchMiner.debug = debug;
        ProcessTreeLSMiner miner = ProcessTreeLSMiner.createInstance(new SimpleDistanceFunction(), StochasticNetUtils.getDummyConsoleProgressContext(), log, emptyTree);
        miner.setTrustLevels(1,0);
        miner.searchForBetterLogAndModel();
        return miner.getBestModel();
    }


    public static NAryTree discoverTreeDumb(XLog log){
        return discoverTreeDumb(log, false);
    }
    /**
     * Special case of the local search miner is discovery
     * @param log
     * @param debug whether to display the intermediate states on GUI
     * @return
     */
    public static NAryTree discoverTreeDumb(XLog log, boolean debug){
        NAryTree emptyTree = new NAryTreeImpl(new int[]{1},new short[]{NAryTree.TAU}, new int[]{NAryTree.NONE});
        LocalSearchMiner.debug = debug;
        ProcessTreeLSMiner miner = ProcessTreeDumbLSMiner.createInstance(new SimpleDistanceFunction(), StochasticNetUtils.getDummyConsoleProgressContext(), log, emptyTree);
        miner.setTrustLevels(1,0);
        miner.searchForBetterLogAndModel();
        return miner.getBestModel();
    }
}
