package org.processmining.generalizedconformance.algorithms.miner;

import org.apache.commons.lang3.tuple.Pair;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.generalizedconformance.algorithms.alignment.LogAbstraction;
import org.processmining.generalizedconformance.algorithms.miner.alignment.AlignmentCollector;
import org.processmining.generalizedconformance.algorithms.miner.distance.Distance;
import org.processmining.generalizedconformance.algorithms.miner.distance.DistanceFunction;
import org.processmining.generalizedconformance.algorithms.miner.move.Neighborhood;
import org.processmining.generalizedconformance.algorithms.miner.move.SearchState;
import org.processmining.models.graphbased.directed.petrinet.*;
import org.processmining.models.graphbased.directed.petrinet.impl.PetrinetFactory;
import org.processmining.models.graphbased.directed.petrinet.impl.ToStochasticNet;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;

/**
 * Created by andreas on 3/22/17.
 */
public class PetrinetLSMiner extends LocalSearchMiner<PetrinetGraph> {

    public PetrinetLSMiner(DistanceFunction function, PluginContext context, XLog log, PetrinetGraph model) {
        super(function, context, log, model);
        throw new UnsupportedOperationException("Petri net search is not yet available! (maybe it never will...)");
    }

    @Override
    protected void visualizeState(PetrinetGraph model) {
        System.out.println("not implemented");
    }

    @Override
    protected PetrinetGraph getClone(PetrinetGraph model) {
        if (model instanceof ResetNet)
            return PetrinetFactory.cloneResetNet((ResetNet) model);
        if (model instanceof Petrinet)
            return PetrinetFactory.clonePetrinet((Petrinet) model);
        if (model instanceof InhibitorNet)
            return PetrinetFactory.cloneInhibitorNet((InhibitorNet) model);
        if (model instanceof StochasticNet)
            return (PetrinetGraph) ToStochasticNet.fromStochasticNet(null, (StochasticNet) model, null)[0];
        throw new IllegalArgumentException(model.getClass()+" not supported in cloning!");
    }



    protected PNRepResult currentAlignment;

    @Override
    protected void computeDistance(SearchState<PetrinetGraph> state) throws DistanceThresholdExceededException {
        // TODO
    }

    @Override
    protected Neighborhood<PetrinetGraph> recomputeNeighborhood(SearchState<PetrinetGraph> state) {
        return null;
    }

    @Override
    protected SearchState<PetrinetGraph> move(Neighborhood<PetrinetGraph> neighborhood, SearchState<PetrinetGraph> currentState) {
        // TODO implement actual change of the state!
        return currentState;
    }

}
