package org.processmining.generalizedconformance.algorithms.miner.alignment;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by andreas on 4/13/17.
 */
public class Alignment {
    private List<AlignmentPiece> alignment;

    private int frequency = 0;

    private int hashCode = 0;

    /**
     * Once we finished collecting, we should turn the alignment into an array backed list
     * @param a
     */
    public Alignment(Alignment a){
        this.alignment = new ArrayList<>(a.alignment);
        this.frequency = a.frequency;
        recalcHashCode();
    }
    public Alignment(int frequency){
        this.alignment = new ArrayList<>();
        this.frequency = frequency;
    }

    public void addPiece(AlignmentPiece alignPiece){
        alignment.add(0,alignPiece);
    }
    public List<AlignmentPiece> getAlignment(){
        return this.alignment;
    }

    public int size() {
        return alignment.size();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Alignment alignment1 = (Alignment) o;

        return hashCode()==alignment1.hashCode();
    }

    @Override
    public String toString() {
        return "Alignment{" +
                "alignment=" + alignment +
                ", frequency=" + frequency +
                ", hash=" + hashCode + "}";
    }

    @Override
    public int hashCode() {
        return hashCode;
    }

    private void recalcHashCode(){
        long result = 1;
        for (AlignmentPiece element : alignment)
            result = 31 * result + (element == null ? 0 : element.hashCode());
        hashCode = (int)result;
    }

    public int getFrequency() {
        return frequency;
    }
    public void incFrequency(int frequency){
        this.frequency += frequency;
    }
}
