package org.processmining.generalizedconformance.algorithms.miner.distance;



public interface DistanceFunction {

    /**
     * Computes some (weighted) average of the individual distance components.
     *
     * @param dist Distance object containing all dimensions of distances between log and model
     * @return the final distance in form of a double. Values should be between 0 (best) and 1 (worst)
     */
    double getFinalDistance(Distance dist);

    /**
     *
     * @param dist Distance object containing all dimensions of distances between log and model
     * @return the distance between the log and model in the current search state (it is usually computed based on
     * precision, fitness, generalization)
     */
    double getModelLogDistance(Distance dist);
}
