package org.processmining.generalizedconformance.algorithms.miner.distance;

/**
 * Created by andreas on 7/11/17.
 */
public class WeightedDistanceFunction extends SimpleDistanceFunction {

    private final double weightLL;
    private final double weightLM;
    private final double weightMM;
    private final double sumWeights;

    public WeightedDistanceFunction(double weightLogLog, double weightLogModel, double weightModelModel){
        this.weightLL = weightLogLog;
        this.weightLM = weightLogModel;
        this.weightMM = weightModelModel;
        this.sumWeights = weightLogLog + weightLogModel + weightModelModel;
    }

    @Override
    public double getFinalDistance(Distance dist) {
        return (this.weightLL*dist.getLogDistance() + this.weightMM*dist.getModelDistance() + this.weightLM*getModelLogDistance(dist)) / sumWeights;
    }

    public String getName(){
        return String.format("(%.1f %.1f %.1f)",weightLL, weightLM, weightMM);
    }
}
