package org.processmining.generalizedconformance.algorithms.mover;

public class TreeMoverConfig {

	public enum Heuristic {
		RANDOM, BEHAVIOURAL_PROFILE, FOOTPRINT, SIMPLE
	}

	private static TreeMoverConfig instance;
	
	private Heuristic heuristic;
	
	public static TreeMoverConfig getInstance(){
		if (instance == null){
			instance = new TreeMoverConfig();
		}
		return instance;
	}
	
	private TreeMoverConfig(){
		heuristic = Heuristic.FOOTPRINT;
	}

	public Heuristic getHeuristic() {
		return heuristic;
	}

	public void setHeuristic(Heuristic heuristic) {
		this.heuristic = heuristic;
	}
	
	
}
