package org.processmining.generalizedconformance.algorithms.util;

import gnu.trove.map.hash.THashMap;
import org.apache.commons.lang3.tuple.MutablePair;
import org.apache.commons.lang3.tuple.Pair;
import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventClasses;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.info.XLogInfo;
import org.deckfour.xes.info.XLogInfoFactory;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.generalizedconformance.algorithms.alignment.LogAbstraction;
import org.processmining.generalizedconformance.algorithms.generator.NAryTreeGenerator;
import org.processmining.plugins.InductiveMiner.efficienttree.EfficientTree;
import org.processmining.plugins.InductiveMiner.efficienttree.ProcessTree2EfficientTree;
import org.processmining.plugins.InductiveMiner.plugins.ProcessTree2EfficientTreePlugin;
import org.processmining.plugins.etm.model.narytree.NAryTree;
import org.processmining.plugins.etm.model.narytree.conversion.NAryTreeToProcessTree;
import org.processmining.processtree.ProcessTree;

import java.util.Map;

/**
 * Created by andreas on 4/25/17.
 */
public class GenerateLogAndModel {

    public static Pair<XLog, NAryTree> generate(int traces, int activities){
        NAryTreeGenerator generator = new NAryTreeGenerator();
        NAryTree tree = generator.generate(20);

        XLog newLog = generateLog(tree,10000);
        return new MutablePair<>(newLog, tree);
    }

    public static XLog generateLog(NAryTree tree, int numberOfTraces) {
        ProcessTree processTree = NAryTreeToProcessTree.convert(tree);
        EfficientTree efficientTree = ProcessTree2EfficientTree.convert(processTree);

        XLog newLog = XFactoryRegistry.instance().currentDefault().createLog();

        GenerateLog simulator = new GenerateLog();

        GenerateLogParameters parameters = new GenerateLogParameters(numberOfTraces,1);
        try {
            for (XTrace trace : simulator.generateTraces(efficientTree, parameters)){
                newLog.add(trace);
            }
        } catch (Exception e) {
            throw new RuntimeException("Trace generation failed",e);
        }
        return newLog;
    }
}
