package org.processmining.generalizedconformance.visualizer;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.generalizedconformance.algorithms.miner.GeneralizedMiner;
import org.processmining.generalizedconformance.precision.EntropyPrecisionRecall;

import javax.swing.*;
import java.awt.*;

public class PrecisionVisualizer {
    @Plugin(name = "Precision Visualizer", returnLabels = { "Visualized Generalized Miner" }, returnTypes = { JComponent.class }, parameterLabels = { GeneralizedMiner.PARAMETER_LABEL }, userAccessible = true)
    @Visualizer
    public static JComponent visualize(PluginContext context, EntropyPrecisionRecall precision){
        JComponent component = new JPanel(new BorderLayout());
        JLabel vennPane = new VennLabel(precision.getLogModelResult().largestEigenvalue, precision.getModelResult().largestEigenvalue, precision.getLogResult().largestEigenvalue, precision.percentFitting);
        JLabel textPane = new JLabel();
        textPane.setText(precision.prettyPrint());
        textPane.setPreferredSize(new Dimension(500,300));
        component.add(vennPane, BorderLayout.CENTER);
        component.add(textPane, BorderLayout.SOUTH);
        return component;
    }
}
